/* implementation of list methods. This file is transformed to list_template.ll
   by make_runtime.py */
#include <stdio.h>

signed char unwind();

struct item {
    char* dummy;
};

struct class {
    char dummy;
};


struct class* LAST_EXCEPTION_TYPE = 0;
struct class INDEX_ERROR = {0};



struct list {
    unsigned int length;
    struct item** data;
};

void copy(struct item** from, struct item** to, unsigned int length) {
    unsigned int i = 0;
    while(i < length) {
	to[i] = from[i];
	i += 1;
    }
}

int len(struct list* l) {
    return (int) l->length;
}

int valid_index(int i, struct list* l) {
    if (i < 0)
	return 0;
    if (i >= len(l))
	return 0;
    return 1;
}

struct list* newlist() {
    struct list* nlist = malloc(sizeof(struct list));
    nlist->length = 0;
    nlist->data = NULL;
    return nlist;
}

struct list* alloc_and_set(int length, struct item* init) {
    unsigned int i = 0;
    struct list* nlist = malloc(sizeof(struct list));
    nlist->length = (unsigned int)length;
    nlist->data = malloc(sizeof(struct item*) * length);
    while (i < length) {
	nlist->data[i] = init;
	i += 1;
    }
    return nlist;
}

struct item* getitem(struct list* l, int index) {
    if (index < 0)
	index = l->length + index;
    return l->data[index];
}

struct item* getitem_EXCEPTION(struct list* l, int index) {
    if (index < 0)
	index = l->length + index;
    if (valid_index(index, l) == 0) {
	LAST_EXCEPTION_TYPE = &INDEX_ERROR;
	return unwind();
    }
    return l->data[index];
}

void setitem(struct list* l, int index, struct item* value) {
    if (index < 0)
	index = l->length + index;
    l->data[index] = value;
}

void setitem_EXCEPTION(struct list* l, int index, struct item* value) {
    if (index < 0)
	index = l->length + index;
    if (valid_index(index, l) == 0) {
	LAST_EXCEPTION_TYPE = &INDEX_ERROR;
	unwind();
	return;
    }
    l->data[index] = value;
}

struct list* add(struct list* a, struct list* b) {
    struct list* nlist = malloc(sizeof(struct list));
    unsigned int newlength = a->length + b->length;
    nlist->length = newlength;
    nlist->data = malloc(sizeof(struct item*) * newlength);
    copy(a->data, nlist->data, a->length);
    copy(b->data, nlist->data + a->length, newlength - a->length);
    return nlist;
}

struct list* mul(struct list* a, int times) {
    struct list* nlist = malloc(sizeof(struct list));
    unsigned int newlength = a->length * times;
    int i = 0;
    nlist->length = newlength;
    nlist->data = malloc(sizeof(struct item*) * newlength);
    while (i < times) {
	copy(a->data, nlist->data + i * a->length, a->length);
	i += 1;
    }
    return nlist;
}

struct list* inplace_add(struct list* a, struct list* b) {
    struct item** newdata = malloc(sizeof(struct item*) * (a->length + b->length));
    copy(a->data, newdata, a->length);
    copy(b->data, newdata + a->length, b->length);
    a->length +=  b->length;
    free(a->data);
    a->data = newdata;
    return a;
}

void append(struct list* a, struct item* value) {
    struct item** newdata = malloc(sizeof(struct item*) * (a->length + 1));
    newdata[a->length] = value;
    copy(a->data, newdata, a->length);
    a->length += 1;
    free(a->data);
    a->data = newdata;
}

struct item* pop(struct list* a, int index) {
    if (index < 0)
	index = a->length + index;
    struct item* ret = a->data[index];
    struct item** newdata = malloc(sizeof(struct item*) * (a->length - 1));
    copy(a->data, newdata, index);
    copy(a->data + index + 1, newdata + index, a->length - 1 - index);
    a->length -= 1;
    free(a->data);
    a->data = newdata;
    return ret;
}

struct item* pop_EXCEPTION(struct list* a, int index) {
    if (index < 0)
	index = a->length + index;
    if (valid_index(index, a) == 0) {
	LAST_EXCEPTION_TYPE = &INDEX_ERROR;
	return unwind();
    }
    struct item* ret = a->data[index];
    struct item** newdata = malloc(sizeof(struct item*) * (a->length - 1));
    copy(a->data, newdata, index);
    copy(a->data + index + 1, newdata + index, a->length - 1 - index);
    a->length -= 1;
    free(a->data);
    a->data = newdata;
    return ret;
}


struct item* pop_ALTERNATIVE1(struct list* a) {
    return pop(a, a->length - 1);
}


void reverse(struct list* a) {
    unsigned int lo = 0;
    unsigned int hi = a->length - 1;
    struct item* temp;
    while (lo < hi) {
	temp = a->data[lo];	    
	a->data[lo] = a->data[hi];
	a->data[hi] = temp;
	lo += 1;
	hi -= 1;
    }
}

